/*
 *    Filename:	CircularSlider.h 
 *    Created :	Sat Aug 24 21:25:44 1991
 *    Author  :	Vince DeMarco
 *		<vince@whatnxt.cuc.ab.ca>
 * 
 *    Version 1.0.1
 */

/* Generated by Interface Builder */

#import <appkit/Control.h>

@interface CircularSlider:Control
{
    float currentang;
    float maxang;
    float radius;
    float x,y;
    struct _CircFlags {
	unsigned int       continuous:1;
        unsigned int       _RESERVED:15;
    } CircFlags;

    id    _target;
    SEL   _action;
}

// if you disable the slider the mouseDown events will be ignore and
// the slider will not sit on a raised background. 
// this is done because if the slider is disabled then i assume that the programer will
// be using it just to indicate how much more the user has to wait before whatever
// is finished

// The rest of the methods below here are almost exactly the same a those for the
// Slider Object.

- initFrame:(NXRect *)nf;

- setContinuous:(BOOL)flag;   
- (BOOL)isContinuous;

- (float)floatValue;
- (double)doubleValue;
- (int)intValue;
- setDoubleValue:(double)value;
- setFloatValue:(float)value;
- setIntValue:(int)value;

- setTheMaxValue:(float)afloat;
- (float)theMaxValue;

//- takeDoubleValueFrom:sender;
//- takeFloatValueFrom:sender;
//- takeIntValueFrom:sender;

- setAction:(SEL)aSelector;
- setTarget:anObject;
- target;
- (SEL)action;

- drawSelf:(const NXRect *)rects : (int)count;
- mouseDown:(NXEvent *)theEvent;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

- (const char *)getInspectorClassName;
@end
